package rsx;

import org.json.JSONObject;
import org.json.JSONException;

/**
 * Analyse reponse d'un serveur BomberStudent
 *
 * @author Arthur Brandao
 */
public class BomberStudentReponse {

    protected boolean error = true;
    protected int statut;
    protected String message;
    protected JSONObject reponse = null;

    /* --- Constructeurs --- */
    public BomberStudentReponse() {

    }

    public BomberStudentReponse(String reponse) {
        this.error = false;
        //Parse reponse
        try {
            JSONObject json = new JSONObject(reponse);
            this.statut = json.getInt("statut");
            this.message = json.getString("message");
            if(json.has("param")){
                this.reponse = json.getJSONObject("param");
            }
            this.error = false;
        } catch(JSONException ex){
            System.err.println("La reponse n'est pas en JSON : " + ex.getMessage());
        }

    }

    /* --- Getter/Setter --- */
    public boolean isError() {
        return error;
    }

    public void setError(boolean error) {
        this.error = error;
    }

    public int getStatut() {
        return statut;
    }

    public void setStatut(int statut) {
        this.statut = statut;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public JSONObject getReponse() {
        return reponse;
    }

    public void setReponse(JSONObject reponse) {
        this.reponse = reponse;
    }

}
